#ifndef __THE_MAZE_OF_GALIOUS_2_VARIABLES
#define __THE_MAZE_OF_GALIOUS_2_VARIABLES


/* GAME / MAP / ROOM / OBJECT VARIABLE CLASS: */ 

#define VALUE_NONE		0
#define VALUE_INTEGER	1
#define VALUE_STRING	2
#define VALUE_OBJECT	3

class VARIABLE {
	// The EDITOR classes can access all the MOG2 members
	friend class EDITOR;
	friend class GVariableWnd;
	friend class MVariableWnd;
	friend class RVariableWnd;
	friend class OVariableWnd;
	friend class AVariableWnd;
	friend class VariableListWnd;
	friend class POVariableWnd;
	friend class IVariableWnd;

	friend class GameDebugWindow;

public:
	VARIABLE(void);
	VARIABLE(char *n,int i);
	VARIABLE(char *n,char *s);
	VARIABLE(char *n,class ActiveOBJECT *o);
	VARIABLE(VARIABLE &v);
	~VARIABLE(void);

	bool save(FILE *fp);
	bool load(FILE *fp);

	bool cmp(char *n);

	int get(int *ival,char **sval,class ActiveOBJECT **oval);
	void set(int v);
	void set(char *sval);
	void set(class ActiveOBJECT *oval);

	void instance(VARIABLE *v);

	char *generate_string(void);

	char *get_name(void);

private:
	char *name;
	int type;
	int ivalue;
	char *svalue;
	class ActiveOBJECT *ovalue;
};

#endif

